#!/bin/bash
#
# Create CA Intermediate
# 
# 
# This function will generate a CA Intermediate
# IN: UNIQ_ID_CA, SERIAL
#

# source this file to include the functions
. pki_funcs.sh

PARAM1=$1
PARAM2=$2

usage() {
  echo
  echo "Generate a new CA Intermediate certificate"
  echo
  echo "This program will generate a new certificate authority (CA) intermediate"
  echo "It requires a CA certificate used to sign CA Intermediate"
  echo "Requires the file \"ca.pem\" that is used to sign the certificates"
  echo ""
  echo ""
  echo ""
  echo
  echo "  usage:   gen_ca-i.sh  <Org URL> <Serial>"
  echo
  echo "  example: gen_ca-i.sh  skunkworks.acme.xyz"
  echo "                        10052"
  echo
  exit 1
}

error_no_ca_file() {
  echo_block "ERROR: missing ca.pem"
  usage
}

main() {
  if [[ ! -f ca-i.pem ]]; then
    error_no_ca_file
  fi

  if [[ -n $PARAM1 ]] || [[ -n $PARAM2 ]]; then
    generate_ca_i $PARAM1 $PARAM2
  else
    usage
  fi
}

main
